var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import axios from 'axios';
import { Auth, AxiosAdapter } from '../../src';
import MockAdapter from 'axios-mock-adapter';
import { createMockInstance } from '../utils';
describe('AxiosAdapter', function () {
    it('perform login request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('login').reply(200);
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    request = { method: 'POST', url: 'login' };
                    return [4 /*yield*/, axiosAdapter.login(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'login' });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform login request with config', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, username, password, auth, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('login').reply(200);
                    username = 'testUsername';
                    password = 'testPassword';
                    auth = { username: username, password: password };
                    axiosAdapter = new AxiosAdapter(axiosInstance, { auth: auth });
                    request = { method: 'POST', url: 'login' };
                    return [4 /*yield*/, axiosAdapter.login(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'login', auth: auth });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform login request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('logout').reply(200);
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    request = { method: 'POST', url: 'logout' };
                    return [4 /*yield*/, axiosAdapter.logout(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'logout' });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform logout request with config', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, username, password, auth, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('logout').reply(200);
                    username = 'testUsername';
                    password = 'testPassword';
                    auth = { username: username, password: password };
                    axiosAdapter = new AxiosAdapter(axiosInstance, { auth: auth });
                    request = { method: 'POST', url: 'logout' };
                    response = axiosAdapter.logout(request);
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'logout', auth: auth });
                    return [4 /*yield*/, response];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    }); });
    it('perform renew request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('renew').reply(200);
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    request = { method: 'POST', url: 'renew' };
                    return [4 /*yield*/, axiosAdapter.renew(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'renew' });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform renew request with config', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, username, password, auth, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('renew').reply(200);
                    username = 'testUsername';
                    password = 'testPassword';
                    auth = { username: username, password: password };
                    axiosAdapter = new AxiosAdapter(axiosInstance, { auth: auth });
                    request = { method: 'POST', url: 'renew' };
                    return [4 /*yield*/, axiosAdapter.renew(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'renew', auth: auth });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('custom').reply(200);
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    request = { method: 'POST', url: 'custom' };
                    return [4 /*yield*/, axiosAdapter.request(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'custom' });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('perform request with config', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, requestSpy, axiosMock, username, password, auth, axiosAdapter, request, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    requestSpy = jest.spyOn(axiosInstance, 'request');
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onPost('custom').reply(200);
                    username = 'testUsername';
                    password = 'testPassword';
                    auth = { username: username, password: password };
                    axiosAdapter = new AxiosAdapter(axiosInstance, { auth: auth });
                    request = { method: 'POST', url: 'custom' };
                    return [4 /*yield*/, axiosAdapter.request(request)];
                case 1:
                    response = _a.sent();
                    expect(requestSpy).toHaveBeenCalledTimes(1);
                    expect(requestSpy).toHaveBeenLastCalledWith({ method: 'POST', url: 'custom' });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('converts to response', function () {
        var axiosInstance = axios.create();
        var axiosAdapter = new AxiosAdapter(axiosInstance);
        var axiosResponse = {
            config: {},
            data: 'testData',
            status: 200,
            statusText: 'OK',
            headers: { testHeader: 'testHeaderValue' }
        };
        var response = axiosAdapter.asResponse(axiosResponse);
        expect(response).toEqual({
            data: axiosResponse.data,
            status: axiosResponse.status,
            headers: axiosResponse.headers
        });
    });
    it('converts to request', function () {
        var axiosInstance = axios.create();
        var axiosAdapter = new AxiosAdapter(axiosInstance);
        var axiosRequest = {
            url: 'testUrl',
            method: 'GET',
            data: 'testData',
            headers: { testHeader: 'testHeaderValue' }
        };
        var response = axiosAdapter.asRequest(axiosRequest);
        expect(response).toEqual({
            url: axiosRequest.url,
            data: axiosRequest.data,
            method: axiosRequest.method,
            headers: axiosRequest.headers
        });
    });
    it('fails to convert to request if url is not defined', function () {
        var axiosInstance = axios.create();
        var axiosAdapter = new AxiosAdapter(axiosInstance);
        var axiosRequest = {
            method: 'GET',
            data: 'testData',
            headers: { testHeader: 'testHeaderValue' }
        };
        expect(function () { return axiosAdapter.asRequest(axiosRequest); }).toThrowError(Error);
    });
    it('fails to convert to request if method is not defined', function () {
        var axiosInstance = axios.create();
        var axiosAdapter = new AxiosAdapter(axiosInstance);
        var axiosRequest = {
            url: 'testUrl',
            data: 'testData',
            headers: { testHeader: 'testHeaderValue' }
        };
        expect(function () { return axiosAdapter.asRequest(axiosRequest); }).toThrowError(Error);
    });
    it('intercept login requests', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, axiosAdapter, axiosMock, interceptRequestMock, authMock, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onGet('testUrl').reply(200);
                    interceptRequestMock = jest.fn(function (request) {
                        request.data = 'interceptedData';
                        request.headers = { interceptedHeader: 'interceptedHeaderValue' };
                        return true;
                    });
                    authMock = createMockInstance(Auth);
                    authMock.interceptRequest = interceptRequestMock;
                    axiosAdapter.setupRequestInterceptor(authMock);
                    return [4 /*yield*/, axiosAdapter.request({ method: 'GET', url: 'testUrl' })];
                case 1:
                    response = _a.sent();
                    expect(authMock.interceptRequest).toHaveBeenLastCalledWith({
                        method: 'get',
                        url: 'testUrl',
                        data: 'interceptedData',
                        headers: { interceptedHeader: 'interceptedHeaderValue' }
                    });
                    return [2 /*return*/, response];
            }
        });
    }); });
    it('intercept login responses', function () { return __awaiter(void 0, void 0, void 0, function () {
        var axiosInstance, axiosAdapter, axiosMock, called, authMock, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    axiosInstance = axios.create();
                    axiosAdapter = new AxiosAdapter(axiosInstance);
                    axiosMock = new MockAdapter(axiosInstance);
                    axiosMock.onGet('testUrl').reply(401);
                    called = false;
                    authMock = createMockInstance(Auth);
                    authMock.interceptResponse = jest.fn(function (request, response) {
                        if (!called) {
                            called = true;
                            return true;
                        }
                        return false;
                    });
                    axiosAdapter.setupErrorResponseInterceptor(authMock);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axiosAdapter.request({ method: 'GET', url: 'testUrl' })];
                case 2:
                    _a.sent();
                    expect(false).toBeTruthy();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    expect(function () {
                        throw e_1;
                    }).toThrow();
                    return [3 /*break*/, 4];
                case 4:
                    expect(authMock.interceptResponse).toHaveBeenCalledTimes(2);
                    expect(authMock.interceptResponse).toHaveBeenLastCalledWith({
                        method: 'get',
                        url: 'testUrl',
                        headers: { Accept: 'application/json, text/plain, */*' }
                    }, {
                        status: 401
                    });
                    return [2 /*return*/, null];
            }
        });
    }); });
});
//# sourceMappingURL=axios-adapter.test.js.map